import { Action } from '@ngrx/store';
import { DegreePlan } from '@app/core/models/degree-plan';
import { PlannedTerm } from '@app/core/models/planned-term';
import { DegreePlannerState } from '@app/degree-planner/store/state';

export enum PlanActionTypes {
  InitialLoadSuccess = '[Plan] Initial Load (Success)',

  SwitchPlan = '[Plan] Switch',
  SwitchPlanSuccess = '[Plan] Switch (Success)',

  PlanError = '[Plan] Error',
}

export class InitialLoadSuccess implements Action {
  public readonly type = PlanActionTypes.InitialLoadSuccess;
  constructor(public payload: DegreePlannerState) {}
}

export class SwitchPlan implements Action {
  public readonly type = PlanActionTypes.SwitchPlan;
  constructor(public payload: { newVisibleRoadmapId: number }) {}
}

export class SwitchPlanSuccess implements Action {
  public readonly type = PlanActionTypes.SwitchPlanSuccess;
  constructor(
    public payload: {
      visibleDegreePlan: DegreePlan;
      visibleTerms: PlannedTerm[];
    },
  ) {}
}

export class PlanError implements Action {
  public readonly type = PlanActionTypes.PlanError;
  constructor(public payload: { message: string; error: any }) {}
}
